<?php

/*
 * This file is part of Resume.PHP.
 *
 * (copyleft) R. Eric Wheeler <sikofitt@gmail.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace Sikofitt\Json;

use Pimple\Container;
use Pimple\ServiceProviderInterface;
use Webmozart\Json\JsonDecoder;
use Webmozart\Json\JsonEncoder;
use Webmozart\Json\JsonValidator;

/**
 * Class JsonServiceProvider
 * @package Sikofitt\Json
 */
class JsonServiceProvider implements ServiceProviderInterface
{

    /**
   * @param Container $app
   */
  public function register(Container $app)
  {
      $app['json.encode'] = function ($app) {
      return new JsonEncoder();
    };
      $app['json.decode'] = function ($app) {
      return new JsonDecoder();
    };
      $app['json.validate'] = function ($app) {
      return new JsonValidator();
    };
  }
}
