<?php

/*
 * This file is part of Resume.PHP.
 *
 * (copyleft) R. Eric Wheeler <sikofitt@gmail.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

/**
 * This file is part of resume.
 *
 * @file Date.php
 *
 * R. Eric Wheeler <reric@ee.stanford.edu>
 *
 * 7/7/16 / 6:57 AM
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace Sikofitt\Twig;

class Date extends \Twig_Extension
{

    public function getName()
    {
        return 'date_diff';
    }

  /**
   * @return array
   *   Array of Twig simple filters.
   */
  public function getFilters()
  {
      return [
      new \Twig_SimpleFilter('date_diff', [$this, 'dateDiff']),
    ];
  }

  /**
   * Calculates the difference in time.
   *
   * @param $startDate
   * @param string $endDate
   *
   * @return \DateTimeInterface
   */
  public function dateDiff($startDate, $endDate = 'now')
  {
      $dt = new \DateTimeImmutable($startDate);
      $dateDifference = $dt->diff(new \DateTime($endDate));
      return $dateDifference->format('%y years');
  }
}
